% opti7.m
% fd, 14, 16   janvier 2006.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel (' opti7. Optimisation a deux variables ; \
methode de quasi-Newton reinitialisee en fin d algorithme   ') ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% axis ( [ .8 , 1.1 , .8  , 1.5 ]) ;
% axis ( [ -.1 , 1.1 , -.1  , 1.5 ]) ;
axis ( [ -1.1 , 1.1 , -.1  , 1.5 ]) ;
xx=zeros(2,1) ; yy=zeros(2,1) ; 
x=-1 ; y = 1 ; 
  x=0  ; y = 0 ; 
  x=-.9  ; y = 0 ; 
   x=-.9  ; y = 1.2 ; 
xx(1:1,1)=x ; yy(1:1,1)=y ; 
hold off 
plot  (1 , 1 ,'*r;fonction de Rosenbrock;')
hold  on

%                          gradient a pas optimal
rho = 1 ;   for j=1:2 ; 
toto=rosen(x,y); ff=toto(1:1,1) ; gx = toto(2:2,1) ; gy=toto(3:3,1) ; ff ; 
x1=x-rho*gx ;   y1=y-rho*gy ; 
xx(1:1,1)=x ; yy(1:1,1)=y ; 

%                               calcul de rho initial 
rhomax=rhoini(x,y,ff,gx,gy);
%                               minimisation a une variable 
rho=min1d(x,y,gx,gy,rhomax) ; 
x1=x-rho*gx ;   y1=y-rho*gy ; 
xx(2:2,1)=x1 ; yy(2:2,1)=y1 ; 
plot(x,y,'*b;;' , xx(:,1) , yy(:,1) ,';;')
x=x-rho*gx ;   y=y-rho*gy ; 
     end ;  
pause
%                un coup de Newton 
%
for j=1:0 ; 
xx(1:1,1)=x ; yy(1:1,1)=y ; 
d2f=zeros(2,2) ; bb=zeros(2,1) ; 
toto=rosen(x,y); ff=toto(1:1,1) ; bb(1:1,1) = toto(2:2,1) ; bb(2:2,1)=toto(3:3,1) ; 
d2f(1:1,1:1) =  toto(4:4,1) ;
d2f(1:1,2:2) =  toto(5:5,1) ;
d2f(2:2,1:1) =  toto(5:5,1) ;
d2f(2:2,2:2) =  toto(6:6,1) ;
d2f ;  bb ; 
cc= d2f \ bb  ;  d2f*cc - bb ; 
% x1=x-.1*cc(1:1,1) ;     y1=y-.1*cc(2:2,1)  ; 
x1=x-cc(1:1,1) ;     y1=y-cc(2:2,1)  ; 
  xx(2:2,1)=x1 ; yy(2:2,1)=y1 ;  plot ( xx(:,1) , yy(:,1) ,';;' )  
     err = sqrt( (x1-x)**2 + (y1-y)**2 ) ; 
     x=x1 ; y=y1 ; 
end ; 
%                methode de Davidon-Fletcher-Powell
%                reinitialiser la matrice toutes les 10 iterations 
for i=1:5 ; 
toto=rosen(x,y); ff=toto(1:1,1) ;  gx = toto(2:2,1) ; gy=toto(3:3,1) ;
descent=zeros(2,1) ; descent(1:1,1)=gx ;  descent(2:2,1)=gy ; 
ss=zeros(2,2) ; ss(1:1,1:1)=1 ;  ss(2:2,2:2)=1 ;
for j=1:10 ; 
xx(1:1,1)=x ; yy(1:1,1)=y ; 
ddx = descent(1:1,1) ; ddy = descent(2:2,1) ; 
%                               minimisation a une variable 
rhomax=rhoini(x,y,ff,ddx,ddy) ; 
rho=min1d(x,y,ddx,ddy,rhomax) ;
x1=x-rho*ddx ;   y1=y-rho*ddy ; 
del = zeros(2,1) ;  del(1:1,1) = -rho*ddx ;  del(2:2,1) = -rho*ddy ; del ; 

toto=rosen(x1,y1); ff=toto(1:1,1) ;  gx1 = toto(2:2,1) ; gy1=toto(3:3,1) ;
grad=zeros(2,1) ;  grad(1:1,1) = gx1 ;  grad(2:2,1) = gy1 ; 
gam=zeros(2,1) ;  gam(1:1,1) = gx1-gx ;  gam(2:2,1) = gy1-gy ; 
den1 = gam(1:1,1) * del(1:1,1) +  gam(2:2,1) * del(2:2,1) ;     
sg=ss*gam ;  den2 =   gam(1:1,1)*sg(1:1,1) +  gam(2:2,1)*sg(2:2,1) ; 
delt = zeros(1,2) ;  delt(1,1:1) =  del(1:1,1) ;  delt(1,2:2) =  del(2:2,1) ; 
sgt = zeros(1,2) ;  sgt(1,1:1) =  sg(1:1,1) ;  sgt(1,2:2) =  sg(2:2,1) ; 
ss = ss + (1/den1) * del*delt  -  (1/den2) * sg*sgt  ; 
descent = ss * grad ; 
tt=ss*gam-del ; % tt doit etre identiquement nul... 

xx(2:2,1)=x1 ; yy(2:2,1)=y1 ;  plot(x,y,'*b;;' , xx(:,1) , yy(:,1) ,';;' )  
     err = sqrt( (x1-x)**2 + (y1-y)**2 ) ; 
     x=x1 ; y=y1 ; 
end ; 
end ;
pause ;  axis ( [ 0.6 ,     1.1  , .6   , 1.1 ]) ;
pause ;  axis ( [ .95 ,     1.05  , .9   , 1.1 ]) ;
pause ;  axis ( [ .995 ,     1.005  , .99   , 1.01 ]) ;
pause ;  axis ( [ .9995 ,    1.0005 ,    .999  ,    1.001 ]) ;
pause ;  axis ( [ .99995 ,   1.00005 ,   .9999  ,   1.0001 ]) ;
% pause ;  axis ( [ .999995 ,  1.000005 ,  .99999 ,   1.00001 ]) ;
format long ;  x , y , err, ecart=sqrt( (x-1)**2 + (y-1)**2) 


